Linux学习-LAMP

本文基于CentOS6.10

  1. 安装httpd
  • 安装pcre-devel
  • 如开启了openssl-devel,则需安装openssl-devel包【yum install openssl-devel -y】
  • 编译安装apr
  • 编译安装apr-util
  • 编译安装httpd
#安装pcre-devel
[root@lotus download]# yum install -y pcre-devel
#安装openssl-devel
[root@lotus download]# yum install -y openssl-devel
#下载apr,apr-utils,httpd
[root@lotus download]# wget https://mirrors.tuna.tsinghua.edu.cn/apache//apr/apr-1.7.0.tar.gz
[root@lotus download]# wget https://archive.apache.org/dist/apr/apr-util-1.5.3.tar.gz
[root@lotus download]# wget wget https://mirrors.tuna.tsinghua.edu.cn/apache//httpd/httpd-2.4.46.tar.gz
#解压
[root@lotus download]# tar -xf apr-1.7.0.tar.gz 
[root@lotus download]# tar -xf apr-util-1.5.3.tar.gz 
[root@lotus download]# tar xf httpd-2.4.46.tar.gz
#安装apr,因apr安装centos时已经安装,为避免覆盖造成其它程序依赖出现问题,安装时指定与源apr不同的安装路径
[root@lotus download]# cd apr-1.7.0
[root@lotus apr-1.7.0]# ./configure --prefix=/usr/local/apr
[root@lotus apr-1.7.0]# make && make install
#安装apr-utils
[root@lotus download]# cd apr-util-1.5.3
[root@lotus apr-util-1.5.3]# ./configure --prefix=/usr/local/apr-util --with-apr=/usr/local/apr
[root@lotus apr-util-1.5.3]# make && make install
#安装httpd
[root@lotus httpd-2.4.46]# ./configure --prefix=/usr/local/apache --sysconfdir=/etc/httpd --enable-so --enable-rewrite --enable-ssl --enable-cgi --enable-cgid --enable-module=most --enable-mods-shared=most --enable-mpms-shared=all --with-apr=/usr/local/apr --with-apr-util=/usr/local/apr-util
[root@lotus httpd-2.4.46]# make && make install
#先关闭httpd服务器,修改httpd.pid文件的存放位置,由于编译安装时指定了httpd的配置文件放入/etc/httpd目录下,到/etc/httpd目录下找到httpd.conf文件,添加一行PidFile /var/run/httpd.pid
#在/etc/init.d/目录编写一个httpd的脚本,实现httpd的启动和停止等功能
#!/bin/bash
#
# httpd Startup script for the Apache HTTP Server
#
# chkconfig:- 85 15
# description:Apache is a World Wide Web Server .It is used to serve \
#         HTML file and CGI.
# processname: httpd
# config: /etc/httpd/conf/httpd.conf
# config: /etc/sysconfig/httpd
# pidfile: /var/run/httpd.pid

# 载入函数库
. /etc/rc.d/init.d/functions

if [ -f /etc/sysconfig/httpd ];then
    .  /etc/sysconfig/httpd
fi

#设定HTTPD_LANG为C
HTTPD_LANG=${HTTPD_LANG="C"}

#This will prevent initlog from swallowing up a pass-parase prompt if 
# mod_ssl needs a pass-phrase from the user.
INITLOG_ARG=""
apachectl=/usr/local/apache/bin/apachectl
#如HTTPD为空,则设定httpd为/usr/local/apche/bin/httpd
httpd=${HTTPD-/usr/local/apache/bin/httpd}
prog=httpd
pidfile=${PIDFILE-/var/run/httpd.pid}
lockfile=${LOCKFILE-/var/lock/subsys/httpd}
RETVAL=0
start() {
    echo -n $"Starting $prog:"
    LANG=$HTTPD_LANG daemon --pidfile=${pidfile} $httpd $OPTIONS
    RETVAL=$?
    echo
    [ $RETVAL = 0 ] && touch ${lockfile}
    return $RETVAL
}
stop() {
    echo -n $"Stopping $prog"
    killproc -p ${pidfile} -d 10 $httpd
    RETVAL=$?
    echo
    [ $RETVAL = 0 ] && rm -f ${lockfile} ${pidfile}
}
reload() {
    echo -n $"Reloading $prog"
    if ! LANG=$HTTPD_LANG $httpd $OPTIONS -t >&/dev/null; then
      RETVAL=$?
      echo $"not reloading due to configuration syntax error"
      failure $"not reloading $httpd due to configuration syntax error"
    else
      killproc -p ${pidfile} $httpd -HUP
      RETVAL=$?
    fi
    echo     
}

case "$1" in
  start)
    start
    ;;
  stop)
    stop
    ;;
  status)
    status -p ${pidfile} $httpd
    RETVAL=$?
    ;;
  restart)
    stop
    start
    ;;
  condrestart)
    if [ -f ${pidfile} ];then
      stop
      start
    fi
    ;;
   reload)
    reload
    ;;
   graceful|help|configtest|fullstatus)
    $apachectl $@
    RETVAL=$?
    ;;
   *)
    echo $"Usage:$prog (start|stop|restart|reload|configtest|status|hep)"
    exit 1
esac
exit $RETVAL
  1. 安装MySQL
#下载二进制包
[root@lotus download]# wget https://downloads.mysql.com/archives/get/p/23/file/mysql-5.6.10-linux-glibc2.5-x86_64.tar.gz
#解压,MySQL二进制包是解压后就可以使用
[root@lotus download]# tar xf  mysql-5.6.10-linux-glibc2.5-x86_64.tar.gz -C /usr/local
#创建软链接
[root@lotus local]# pwd
/usr/local
[root@lotus local]# ln -sv mysql-5.6.10-linux-glibc2.5-x86_64 mysql
#添加mysql用户,mysql组
[root@lotus local]# groupadd -r -g 306 mysql
[root@lotus local]# useradd -g 306 -r -u 306 mysql
#修改mysql文件目录的属主,属组
[root@lotus mysql]# pwd
/usr/local/mysql
[root@lotus mysql]# chown -R mysql.mysql .
#初使化mysql,建议将数据库文件放到一个独立的分区,独立的逻辑卷上面,本文简单放入至单独的目录【/data】
[root@lotus mysql]# mkdir /data
[root@lotus mysql]# chown mysql.mysql /data
#减小其它用户权限为不能访问
[root@lotus mysql]# chmod o-x /data
#初使化mysql服务器
[root@lotus mysql]# scripts/mysql_install_db --user=mysql --datadir=/data/
#修改mysql目录下的文件的属主为root
[root@lotus mysql]# chown -R root .
#复制mysql启动脚本至/etc/init.d目录下
[root@lotus mysql]# cp support-files/mysql.server /etc/init.d/mysqld
#加入开机启动列表
[root@lotus mysql]# chkconfig --add mysqld
[root@lotus mysql]# chkconfig --list mysqld
mysqld         	0:off	1:off	2:on	3:on	4:on	5:on	6:off
#修改配置文件
[root@lotus mysql]# vim /etc/my.cnf

[mysqld]

# Remove leading # and set to the amount of RAM for the most important data
# cache in MySQL. Start at 70% of total RAM for dedicated server, else 10%.
# innodb_buffer_pool_size = 128M

# Remove leading # to turn on a very important data integrity option: logging
# changes to the binary log between backups.
# log_bin
#
# These are commonly set, remove the # and set as required.
basedir = /usr/local/mysql
datadir = /data
port = 3306
# server_id = .....
socket = /tmp/mysql.sock
thread_cache_size=8
query_cache_size=16M
sort_buffer_size=1M
read_buffer_size=1M
read_rnd_buffer_size=4M
myisam_sort_buffer_size=64M
max_allowed_packet=1M
key_buffer_size=256M
skip-external-locking
thread_concurrency=2
#启动MySQL
[root@lotus mysql]# service mysqld start
Starting MySQL. SUCCESS! 
#添加/etc/profile.d/mysql.sh文件,增加mysql的bin目录到环境变量
[root@lotus mysql]# vim /etc/profile.d/mysql.sh
export PATH=$PATH:/usr/local/mysql/bin
#输出mysql的头文件和库文件
[root@lotus mysql]# vim /etc/ld.so.conf.d/mysql-x86_64.conf
/usr/local/mysql/lib
#重读库文件
[root@lotus mysql]# ldconfig -v
#输出头文件
[root@lotus mysql]# ln -sv /usr/local/mysql/include /usr/include/mysql

报错:

[root@lotus ~]# mysql
ERROR 2002 (HY000): Can't connect to local MySQL server through socket '/var/lib/mysql/mysql.sock' (2)

解决方法:

修改mysql的配置文件
添加
[client]
socket=同mysqld配置的socket
  1. 安装PHP
    PHP安装链接
#安装libxml2-devel包
[root@lotus php-5.4.45]# yum install -y libxml2-devel
#安装bzip2-devel
[root@lotus ~]# yum install -y bzip2-devel
#编译安装libmcrypt
[root@lotus ~]# wget https://sourceforge.net/projects/mcrypt/files/Libmcrypt/2.5.8/libmcrypt-2.5.8.tar.gz
[root@lotus ~]# tar xf libmcrypt-2.5.8.tar.gz 
[root@lotus ~]# cd libmcrypt-2.5.8
[root@lotus libmcrypt-2.5.8]# ./configure
[root@lotus libmcrypt-2.5.8]# make && make install
#下载php
[root@lotus ~]# wget https://www.php.net/distributions/php-5.4.45.tar.gz
#解压
[root@lotus ~]# tar xf php-5.4.45.tar.gz 
[root@lotus ~]# cd php-5.4.45
#编译安装
[root@lotus php-5.4.45]#  ./configure --prefix=/usr/local/php --with-mysql=/usr/local/mysql --with-openssl --with-mysqli=/usr/local/mysql/bin/mysql_config --enable-mbstring --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml --enable-sockets --with-apxs2=/usr/local/apache/bin/apxs --with-mcrypt --with-config-file-path=/etc --with-config-file-scan-dir=/etc/php.d --with-bz2 --enable-maintainer-zts
#复制配置文件
[root@lotus php-5.4.45]# cp php.ini-production /etc/php.ini
#修改httpd配置文件,让httpd服务器可以解析php文件
#/etc/httpd/httpd.conf
  AddType application/x-httpd-php .php
  AddType application/x-httpd-php-source .phps
  #添加php文件
  <IfModule dir_module>
    DirectoryIndex index.php index.html
</IfModule>

#修改原html文件为php文件
[root@lotus php-5.4.45]# mv /usr/local/apache/htdocs/index.html /usr/local/apache/htdocs/index.php
#测试php文件
#在index.php文件中,添加php代码
<html><body><h1>It works!</h1>

<?php
phpinfo();
?>
</body></html>

测试结果:
在这里插入图片描述
测试php与mysql的连通性

#修改index.php文件
<html><body><h1>It works!</h1>

<?php
$conn=mysql_connect("localhost","root","");
if ($conn)
  echo "Successfullly Connect MySQL...";
else
  echo "Failure...";
phpinfo();
?>
</body></html>

测试结果:
在这里插入图片描述
关闭mysql服务器,测试结果如下
在这里插入图片描述

热门文章

暂无图片
编程学习 ·

exe4j详细使用教程(附下载安装链接)

一、exe4j介绍 ​ exe4j是一个帮助你集成Java应用程序到Windows操作环境的java可执行文件生成工具&#xff0c;无论这些应用是用于服务器&#xff0c;还是图形用户界面&#xff08;GUI&#xff09;或命令行的应用程序。如果你想在任务管理器中及Windows XP分组的用户友好任务栏…
暂无图片
编程学习 ·

AUTOSAR从入门到精通100讲(126)-浅谈车载充电系统通信方案

01 引言 本文深入研究车载充电系统策略,设计出一套基于电动汽车电池管理系统与车载充电机的CAN通信协议,可供电动汽车设计人员参考借鉴。 02 电动汽车充电系统通讯网络 电动汽车整车控制系统中采用的是CAN总线通信方式,由一个整车内部高速CAN网络、内部低速CAN网络和一个充电…
暂无图片
编程学习 ·

CMake(九):生成器表达式

当运行CMake时&#xff0c;开发人员倾向于认为它是一个简单的步骤&#xff0c;需要读取项目的CMakeLists.txt文件&#xff0c;并生成相关的特定于生成器的项目文件集(例如Visual Studio解决方案和项目文件&#xff0c;Xcode项目&#xff0c;Unix Makefiles或Ninja输入文件)。然…
暂无图片
编程学习 ·

47.第十章 网络协议和管理配置 -- 网络配置(八)

4.3.3 route 命令 路由表管理命令 路由表主要构成: Destination: 目标网络ID,表示可以到达的目标网络ID,0.0.0.0/0 表示所有未知网络,又称为默认路由,优先级最低Genmask:目标网络对应的netmaskIface: 到达对应网络,应该从当前主机哪个网卡发送出来Gateway: 到达非直连的网络,…
暂无图片
编程学习 ·

元宇宙技术基础

请看图&#xff1a; 1、通过AR、VR等交互技术提升游戏的沉浸感 回顾游戏的发展历程&#xff0c;沉浸感的提升一直是技术突破的主要方向。从《愤怒的小鸟》到CSGO,游戏建模方式从2D到3D的提升使游戏中的物体呈现立体感。玩家在游戏中可以只有切换视角&#xff0c;进而提升沉浸…
暂无图片
编程学习 ·

flink的伪分布式搭建

一 flink的伪分布式搭建 1.1 执行架构图 1.Flink程序需要提交给 Job Client2.Job Client将作业提交给 Job Manager3.Job Manager负责协调资源分配和作业执行。 资源分配完成后&#xff0c;任务将提交给相应的 Task Manage。4.Task Manager启动一个线程以开始执行。Task Manage…
暂无图片
编程学习 ·

十进制正整数与二进制字符串的转换(C++)

Function one&#xff1a; //十进制数字转成二进制字符串 string Binary(int x) {string s "";while(x){if(x % 2 0) s 0 s;else s 1 s;x / 2;}return s; } Function two&#xff1a; //二进制字符串变为十进制数字 int Decimal(string s) {int num 0, …
暂无图片
编程学习 ·

[含lw+源码等]微信小程序校园辩论管理平台+后台管理系统[包运行成功]Java毕业设计计算机毕设

项目功能简介: 《微信小程序校园辩论管理平台后台管理系统》该项目含有源码、论文等资料、配套开发软件、软件安装教程、项目发布教程等 本系统包含微信小程序做的辩论管理前台和Java做的后台管理系统&#xff1a; 微信小程序——辩论管理前台涉及技术&#xff1a;WXML 和 WXS…
暂无图片
编程学习 ·

树莓派驱动DHT11温湿度传感器

1&#xff0c;直接使用python库 代码如下 import RPi.GPIO as GPIO import dht11 import time import datetimeGPIO.setwarnings(True) GPIO.setmode(GPIO.BCM)instance dht11.DHT11(pin14)try:while True:result instance.read()if result.is_valid():print(ok)print(&quo…
暂无图片
编程学习 ·

ELK简介

ELK简介 ELK是三个开源软件的缩写&#xff0c;Elasticsearch、Logstash、Kibana。它们都是开源软件。不过现在还新增了一个 Beats&#xff0c;它是一个轻量级的日志收集处理工具(Agent)&#xff0c;Beats 占用资源少&#xff0c;适合于在各个服务器上搜集日志后传输给 Logstas…
暂无图片
编程学习 ·

Linux 基础

通常大数据框架都部署在 Linux 服务器上&#xff0c;所以需要具备一定的 Linux 知识。Linux 书籍当中比较著名的是 《鸟哥私房菜》系列&#xff0c;这个系列很全面也很经典。但如果你希望能够快速地入门&#xff0c;这里推荐《Linux 就该这么学》&#xff0c;其网站上有免费的电…
暂无图片
编程学习 ·

Windows2022 无线网卡装不上驱动

想来 Windows2022 和 windows10/11 的驱动应该差不多通用的&#xff0c;但是死活装不上呢&#xff1f; 搜一下&#xff0c;有人提到 “默认安装时‘无线LAN服务’是关闭的&#xff0c;如果需要开启&#xff0c;只需要在“添加角色和功能”中&#xff0c;选择开启“无线LAN服务…
暂无图片
编程学习 ·

【嵌入式面试宝典】版本控制工具Git常用命令总结

目录 创建仓库 查看信息 版本回退 版本检出 远程库 Git 创建仓库 git initgit add <file> 可反复多次使用&#xff0c;添加多个文件git commit -m <message> 查看信息 git status 仓库当前的状态git diff 差异对比git log 历史记录&#xff0c;提交日志--pret…
暂无图片
编程学习 ·

用Postman生成测试报告

newman newman是一款基于nodejs开发的可以运行postman脚本的工具&#xff0c;使用Newman&#xff0c;可以直接从命令运行和测试postman集合。 安装nodejs 下载地址&#xff1a;https://nodejs.org/en/download/ 选择自己系统相对应的版本内容进行下载&#xff0c;然后傻瓜式安…
暂无图片
编程学习 ·

Java面向对象之多态、向上转型和向下转型

文章目录前言一、多态二、引用类型之间的转换Ⅰ.向上转型Ⅱ.向下转型总结前言 今天继续Java面向对象的学习&#xff0c;学习面向对象的第三大特征&#xff1a;多态&#xff0c;了解多态的意义&#xff0c;以及两种引用类型之间的转换&#xff1a;向上转型、向下转型。  希望能…